/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.ObjekModulAplikasiDao;
import com.portofolio.dto.ObjekModulAplikasiDto;
import com.portofolio.entity.ObjekModulAplikasi;
import com.portofolio.entity.ObjekModulAplikasi;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class ObjekModulAplikasiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	ObjekModulAplikasiDao objekmodulaplikasiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(ObjekModulAplikasiDto objekmodulaplikasiDto) {
		result.clear();
		String kdObjekModulAplikasi = String.format("%06d",
				getIdTerahirNoNegara(ObjekModulAplikasi.class, "kdObjekModulAplikasi"));
		ObjekModulAplikasi objekmodulaplikasi = CommonUtil.findOne(objekmodulaplikasiDao, kdObjekModulAplikasi);
		if (CommonUtil.isNullOrEmpty(objekmodulaplikasi)) {
			checkObject(objekmodulaplikasiDto.getAlamatURLFormObjek());
			objekmodulaplikasi = new ObjekModulAplikasi();
			objekmodulaplikasi.setNoRec(generateUuid32());
			objekmodulaplikasi.setVersion(1);
			objekmodulaplikasi.setKdObjekModulAplikasi(kdObjekModulAplikasi);
			BeanUtils.copyProperties(objekmodulaplikasiDto, objekmodulaplikasi);
			objekmodulaplikasi = objekmodulaplikasiDao.save(objekmodulaplikasi);
			result.put("objekmodulaplikasi", objekmodulaplikasi);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("desaKelurahan.message.dataAlreadyExist"));
		}

		return result;
	}
	
	@Transactional
	public Map<String, Object> update(ObjekModulAplikasiDto objekmodulaplikasiDto, String kdObjekModulAplikasi,Integer version) {
		result.clear();
		ObjekModulAplikasi objekmodulaplikasi = CommonUtil.findOne(objekmodulaplikasiDao, kdObjekModulAplikasi);
		if (CommonUtil.isNotNullOrEmpty(objekmodulaplikasi)) {
			if (version < objekmodulaplikasi.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(objekmodulaplikasiDto, objekmodulaplikasi);
			objekmodulaplikasi = objekmodulaplikasiDao.save(objekmodulaplikasi);
			result.put("objekmodulaplikasi", objekmodulaplikasi);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}
	
	@Transactional
	public Map<String, Object> delete(String kdObjekModulAplikasi, Integer version) {
		result.clear();
		ObjekModulAplikasi objekmodulaplikasi = CommonUtil.findOne(objekmodulaplikasiDao, kdObjekModulAplikasi);
		if (CommonUtil.isNotNullOrEmpty(objekmodulaplikasi)) {
			if (version < objekmodulaplikasi.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			objekmodulaplikasi.setStatusEnabled(false);
			objekmodulaplikasi = objekmodulaplikasiDao.save(objekmodulaplikasi);
			result.put("objekmodulaplikasi", objekmodulaplikasi);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}
	
	public Map<String, Object> grid(String sort, String dir, String namaObjekModulAplikasi) {
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<ObjekModulAplikasi> list = new ArrayList<>();
		if (CommonUtil.isNullOrEmpty(namaObjekModulAplikasi)) {
			list = objekmodulaplikasiDao.findAllList(pageReq);
			result = createTree(list);
		} else {
			list = objekmodulaplikasiDao.findAllList(namaObjekModulAplikasi, pageReq);
			result = createTree(list);
		}
		resultSuccessful();

		return result;
	}
	
	
	public Map<String, Object> combo(String sort, String dir, String namaObjekModulAplikasi) {
		PageRequest pageReq = new PageRequest(0, Integer.MAX_VALUE,"desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		List<ObjekModulAplikasi> list = new ArrayList<>();
		if (CommonUtil.isNullOrEmpty(namaObjekModulAplikasi)) {
			list = objekmodulaplikasiDao.findAllListCombo(pageReq);
			result = createTree(list);
		} else {
			list = objekmodulaplikasiDao.findAllListCombo(namaObjekModulAplikasi, pageReq);
			result = createTree(list);
		}
		resultSuccessful();

		return result;
	}
	
	public Map<String, Object> checkObject(String alamatURLFormObjek) {
		if (!alamatURLFormObjek.equals("/#") && !alamatURLFormObjek.equals("#") && !alamatURLFormObjek.equals("#/")) {
			Long cnt = objekmodulaplikasiDao.countByAlamatURLFormObjek(alamatURLFormObjek);
			if (cnt != 0) {
				throw new InfoException("URL Objek Modul Aplikasi Sudah Digunakan");
			}
		}
		return null;
	}


	private Map<String, Object> createTree(List<ObjekModulAplikasi> nodes) {


		Map<String, ObjekModulAplikasi> mapTmp = new HashMap<>();

		// Save all nodes to a map
		for (ObjekModulAplikasi current : nodes) {
			mapTmp.put(current.getKdObjekModulAplikasi().toString(), current);
		}

		// loop and assign parent/child relationships
		for (ObjekModulAplikasi current : nodes) {
			String parentId = current.getKdObjekModulAplikasiHead();

			if (parentId != null) {
				ObjekModulAplikasi parent = mapTmp.get(parentId);
				if (parent != null) {
					// current.setVersionHead(parent);
					parent.addChild(current);
					mapTmp.put(parentId, parent);
					mapTmp.put(current.getKdObjekModulAplikasi(), current);
				}
			}
		}

		List<ObjekModulAplikasi> objekModulAplikasis = new ArrayList<>();
		for (ObjekModulAplikasi d : mapTmp.values()) {
			if (CommonUtil.isNullOrEmpty(d.getKdObjekModulAplikasiHead()) || CommonUtil.isNotNullOrEmpty(d.getChildren())) {
				objekModulAplikasis.add(d);
			}

		}
		Map<String, Object> da = new HashMap<>();
		da.put("objekModulAplikasis", objekModulAplikasis);
		return da;
	
	}
	
	public Map<String, Object> findByKdObjekModulAplikasi(String kdObjekModulAplikasi, boolean isHierarki) {
		result.clear();
		List<ObjekModulAplikasi> list = new ArrayList<>();
		if (isHierarki) {
			list = objekmodulaplikasiDao.findByKdObjekModulAplikasiWithIsHierarkiTrue(kdObjekModulAplikasi);
			result = createTree(list);
		} else {
			list = objekmodulaplikasiDao.findByKdObjekModulAplikasiWithIsHierarkiFalse(kdObjekModulAplikasi);
			result.put("objekModulAplikasis", list);
		}
		resultSuccessful();
		return result;

	}
	
	public List<Map<String, Object>> treeObjekModulAplikasi(String kdObjekModulAplikasi) {
		List<Map<String,Object>> listObjectModulAplikasiByHead=objekmodulaplikasiDao.findObjekModulAplikasiByHead(kdObjekModulAplikasi);
		List<Map<String,Object>> tmpListObjectModulAplikasiByHead=new ArrayList<Map<String,Object>>();
		for(Map<String,Object> object:listObjectModulAplikasiByHead) {
			tmpListObjectModulAplikasiByHead.add(object);
		}
		return listObjectModulAplikasiByHead;
		
	}
	
	
	

	


}